<?php

namespace Gigneo\Elementor\Widgets;

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

use Elementor\Controls_Manager;
use Elementor\Group_Control_Background;
use Elementor\Group_Control_Border;
use Elementor\Group_Control_Box_Shadow;
use Elementor\Group_Control_Typography;
use Elementor\Widget_Base;

/**
 * Gigneo Elementor User_Menu Widget
 *
 * @since 0.0.1
 */
class User_Menu extends Widget_Base {


	/**
	 * Get widget unique name.
	 *
	 * @return string
	 */
	public function get_name() {
		return 'gigneo-user-menu';
	}

	/**
	 * Get widget title.
	 *
	 * This is the name displayed in the Elementor panel.
	 *
	 * @return string
	 */
	public function get_title() {
		return __( 'User Menu', 'gigneo' );
	}

	/**
	 * Get widget icon.
	 *
	 * Define the icon that will appear in the Elementor panel.
	 *
	 * @return string
	 */
	public function get_icon() {
		return 'eicon-lock-user gn-label';
	}

	/**
	 * Get widget categories.
	 *
	 * Defines the category under which the widget will be listed.
	 *
	 * @return array
	 */
	public function get_categories() {
		return array( 'gigneo-widgets' );
	}

	/**
	 * Get widget keywords.
	 *
	 * Helps users find the widget in Elementor search.
	 *
	 * @return array
	 */
	public function get_keywords() {
		return array( 'user', 'menu' );
	}

	/**
	 * Register widget controls.
	 *
	 * Adds controls/fields to the Elementor editor for this widget.
	 */
	protected function register_controls() {
		$this->start_controls_section(
			'section_general',
			array(
				'label' => __( 'General', 'gigneo' ),
			)
		);

		$this->add_control(
			'preview_type',
			array(
				'label'   => esc_html__( 'Preview Type', 'gigneo' ),
				'type'    => Controls_Manager::SELECT,
				'default' => 'menu',
				'options' => array(
					'action' => esc_html__( 'Actions', 'gigneo' ),
					'menu'   => esc_html__( 'User Menu', 'gigneo' ),
				),
			)
		);

		$this->add_control(
			'preview_dropdown',
			array(
				'label'        => esc_html__( 'Dropdown', 'gigneo' ),
				'type'         => Controls_Manager::SWITCHER,
				'label_on'     => esc_html__( 'Show', 'gigneo' ),
				'label_off'    => esc_html__( 'Hide', 'gigneo' ),
				'return_value' => 'yes',
				'selectors'    => array(
					'body.elementor-editor-active {{WRAPPER}} .gn-user-action-menu .gn-user-menu-dropdown' => 'display: block;',
				),
				'condition'    => array(
					'preview_type' => 'menu',
				),
			)
		);

		$this->add_responsive_control(
			'align',
			array(
				'label'     => esc_html__( 'Alignment', 'gigneo' ),
				'type'      => Controls_Manager::CHOOSE,
				'separator' => 'before',
				'options'   => array(
					'left'    => array(
						'title' => esc_html__( 'Left', 'gigneo' ),
						'icon'  => 'eicon-text-align-left',
					),
					'center'  => array(
						'title' => esc_html__( 'Center', 'gigneo' ),
						'icon'  => 'eicon-text-align-center',
					),
					'right'   => array(
						'title' => esc_html__( 'Right', 'gigneo' ),
						'icon'  => 'eicon-text-align-right',
					),
					'justify' => array(
						'title' => esc_html__( 'Justified', 'gigneo' ),
						'icon'  => 'eicon-text-align-justify',
					),
				),
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}}' => 'text-align: {{VALUE}};',
				),
			)
		);

		$this->end_controls_section();

		//Styling
		$this->start_controls_section(
			'section_login_btn_style',
			array(
				'label' => esc_html__( 'Login Button', 'gigneo' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'login_btn_typography',
				'selector' => '{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn',
			)
		);

		$this->start_controls_tabs( 'login_btn_tabs' );

		$this->start_controls_tab(
			'login_btn_normal_tab',
			array(
				'label' => esc_html__( 'Normal', 'gigneo' ),
			)
		);

		$this->add_control(
			'login_btn_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn' => 'fill: {{VALUE}}; color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Background::get_type(),
			array(
				'name'     => 'login_btn_background',
				'types'    => array( 'classic', 'gradient' ),
				'exclude'  => array( 'image' ), // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
				'selector' => '{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn',
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'login_btn_box_shadow',
				'selector' => '{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'login_btn_hover_tab',
			array(
				'label' => esc_html__( 'Hover', 'gigneo' ),
			)
		);

		$this->add_control(
			'login_btn_color_hover',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn:hover, {{WRAPPER}} .gn-user-auth-buttons .gn-login-btn:focus' => 'color: {{VALUE}};',
					'{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn:hover svg, {{WRAPPER}} .gn-user-auth-buttons .gn-login-btn:focus svg' => 'fill: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Background::get_type(),
			array(
				'name'     => 'login_btn_background_hover',
				'types'    => array( 'classic', 'gradient' ),
				'exclude'  => array( 'image' ), // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
				'selector' => '{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn:hover, {{WRAPPER}} .gn-user-auth-buttons .gn-login-btn:focus',

			)
		);

		$this->add_control(
			'login_btn_border_color_hover',
			array(
				'label'     => esc_html__( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn:hover, {{WRAPPER}} .gn-user-auth-buttons .gn-login-btn:focus' => 'border-color: {{VALUE}};',
				),

			)
		);

		$this->add_control(
			'login_btn_transition_duration',
			array(
				'label'      => esc_html__( 'Transition Duration', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 's', 'ms', 'custom' ),
				'default'    => array(
					'unit' => 's',
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn' => 'transition-duration: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'      => 'login_btn_border',
				'selector'  => '{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn',
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'login_btn_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'login_btn_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'login_btn_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-login-btn' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'section_signup_btn_style',
			array(
				'label' => esc_html__( 'Signup Button', 'gigneo' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'signup_btn_typography',
				'selector' => '{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn',
			)
		);

		$this->start_controls_tabs( 'signup_btn_tabs' );

		$this->start_controls_tab(
			'signup_btn_normal_tab',
			array(
				'label' => esc_html__( 'Normal', 'gigneo' ),
			)
		);

		$this->add_control(
			'signup_btn_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn' => 'fill: {{VALUE}}; color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Background::get_type(),
			array(
				'name'     => 'signup_btn_background',
				'types'    => array( 'classic', 'gradient' ),
				'exclude'  => array( 'image' ), // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
				'selector' => '{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn',
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'signup_btn_box_shadow',
				'selector' => '{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'signup_btn_hover_tab',
			array(
				'label' => esc_html__( 'Hover', 'gigneo' ),
			)
		);

		$this->add_control(
			'signup_btn_color_hover',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn:hover, {{WRAPPER}} .gn-user-auth-buttons .gn-register-btn:focus' => 'color: {{VALUE}};',
					'{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn:hover svg, {{WRAPPER}} .gn-user-auth-buttons .gn-register-btn:focus svg' => 'fill: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Background::get_type(),
			array(
				'name'     => 'signup_btn_background_hover',
				'types'    => array( 'classic', 'gradient' ),
				'exclude'  => array( 'image' ), // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
				'selector' => '{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn:hover, {{WRAPPER}} .gn-user-auth-buttons .gn-register-btn:focus',

			)
		);

		$this->add_control(
			'signup_btn_border_color_hover',
			array(
				'label'     => esc_html__( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn:hover, {{WRAPPER}} .gn-user-auth-buttons .gn-register-btn:focus' => 'border-color: {{VALUE}};',
				),

			)
		);

		$this->add_control(
			'signup_btn_transition_duration_hover',
			array(
				'label'      => esc_html__( 'Transition Duration', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 's', 'ms', 'custom' ),
				'default'    => array(
					'unit' => 's',
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn' => 'transition-duration: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'      => 'signup_btn_border',
				'selector'  => '{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn',
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'signup_btn_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'signup_btn_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'signup_btn_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-auth-buttons .gn-register-btn' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();

		// Menu Avatar
		$this->start_controls_section(
			'section_user_menu_toggle_style',
			array(
				'label' => esc_html__( 'User Menu Toggle', 'gigneo' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_responsive_control(
			'section_user_menu_toggle_size',
			array(
				'label'      => esc_html__( 'Size', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem' ),
				'range'      => array(
					'px'  => array(
						'min' => 8,
						'max' => 50,
					),
					'em'  => array(
						'min' => 0.5,
						'max' => 3,
					),
					'rem' => array(
						'min' => 0.5,
						'max' => 3,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-action-menu-wrapper .gn-user-avatar' => 'height: {{SIZE}}{{UNIT}}; width: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'user_menu_toggle_box_shadow',
				// phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
				'exclude'  => array(
					'box_shadow_position',
				),
				'selector' => '{{WRAPPER}} .gn-action-menu-wrapper .gn-user-avatar',
			)
		);

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'     => 'user_menu_toggle_border',
				'selector' => '{{WRAPPER}} .gn-action-menu-wrapper .gn-user-avatar',
			)
		);

		$this->add_responsive_control(
			'user_menu_toggle_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-action-menu-wrapper .gn-user-avatar' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'user_menu_dropdown_heading',
			array(
				'label'     => esc_html__( 'Dropdown', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'user_menu_dropdown_width',
			array(
				'label'      => esc_html__( 'Width', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'vw' ),
				'range'      => array(
					'px' => array(
						'min' => 0,
						'max' => 300,
					),
					'vw' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-dropdown' => 'width: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'user_menu_dropdown_background',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-dropdown' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'user_menu_dropdown_box_shadow',
				'selector' => '{{WRAPPER}} .gn-user-menu-dropdown',
			)
		);

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'     => 'user_menu_dropdown_border',
				'selector' => '{{WRAPPER}} .gn-user-menu-dropdown',
			)
		);

		$this->add_responsive_control(
			'user_menu_dropdown_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-dropdown' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'user_menu_dropdown_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-dropdown' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'user_menu_dropdown_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-dropdown' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'user_menu_dropdown_avatar',
			array(
				'label'     => esc_html__( 'Avatar', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'user_menu_dropdown_avatar_size',
			array(
				'label'      => esc_html__( 'Size', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem' ),
				'range'      => array(
					'px'  => array(
						'min' => 8,
						'max' => 10,
					),
					'em'  => array(
						'min' => 0.5,
						'max' => 3,
					),
					'rem' => array(
						'min' => 0.5,
						'max' => 3,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-dropdown .gn-user-profile img' => 'height: {{SIZE}}{{UNIT}}; width: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'user_menu_dropdown_avatar_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-dropdown .gn-user-profile img' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'user_menu_dropdown_name',
			array(
				'label'     => esc_html__( 'Name', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'user_menu_dropdown_name_typo',
				'selector' => '{{WRAPPER}} .gn-user-menu-dropdown .gn-user-menu-header .gn-user-profile .gn-name',
			)
		);

		$this->add_control(
			'user_menu_dropdown_name_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-dropdown .gn-user-menu-header .gn-user-profile .gn-name' => 'color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'profile_type_heading',
			array(
				'label'     => esc_html__( 'Profile Type', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'profile_type_typo',
				'selector' => '{{WRAPPER}} .gn-user-menu-dropdown .gn-user-profile .gn-email',
			)
		);

		$this->add_control(
			'profile_type_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-dropdown .gn-user-profile .gn-email' => 'color: {{VALUE}}',
				),
			)
		);

		$this->add_responsive_control(
			'profile_type_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-dropdown .gn-user-profile .gn-email' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'separator_heading',
			array(
				'label'     => esc_html__( 'Separator', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'separator_height',
			array(
				'label'      => esc_html__( 'Size', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-dropdown .gn-separator' => 'height: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'separator_background',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-dropdown .gn-separator' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'separator_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-dropdown .gn-separator' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'list_heading',
			array(
				'label'     => esc_html__( 'List', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'list_typography',
				'selector' => '{{WRAPPER}} .gn-user-menu-list li > a > .title',
			)
		);

		$this->add_responsive_control(
			'list_icon_size',
			array(
				'label'      => esc_html__( 'Icon Size', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
                'range' => [
                    'px' => [
                        'min' => 10,
                        'max' => 30,
                        'step' => 1,
                    ],
                ],
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-list li > a > i' => 'font-size: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'list_space_between',
			array(
				'label'      => esc_html__( 'Space Between', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
                'range' => [
                    'px' => [
                        'min' => 0,
                        'max' => 30,
                        'step' => 1,
                    ],
                ],
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-dropdown .gn-user-menu-list' => 'gap: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->start_controls_tabs(
			'list_tabs'
		);

		$this->start_controls_tab(
			'list_normal_tab',
			array(
				'label' => esc_html__( 'Normal', 'gigneo' ),
			)
		);

		$this->add_control(
			'list_icon_color',
			array(
				'label'     => esc_html__( 'Icon Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-list li > a > i' => 'color: {{VALUE}};',
					'{{WRAPPER}} .gn-user-menu-list li > a > svg' => 'fill: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'list_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-list li > a > .title' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'list_background',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-list li > a' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'list_hover_tab',
			array(
				'label' => esc_html__( 'Hover', 'gigneo' ),
			)
		);

		$this->add_control(
			'list_icon_color_hover',
			array(
				'label'     => esc_html__( 'Icon Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-list li > a:hover > i' => 'color: {{VALUE}};',
					'{{WRAPPER}} .gn-user-menu-list li > a:hover > svg' => 'fill: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'list_text_color_hover',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-list li > a:hover > .title' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'list_background_hover',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-list li > a:hover' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'list_border_color_hover',
			array(
				'label'     => esc_html__( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-list li > a:hover' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'      => 'list_border',
				'selector'  => '{{WRAPPER}} .gn-user-menu-list li > a',
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'list_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-list li > a' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'list_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-list li > a' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'list_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-dropdown .gn-user-menu-list' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'user_menu_dropdown_sign_out_heading',
			array(
				'label'     => esc_html__( 'Sign Out', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'user_menu_dropdown_sign_out_typography',
				'selector' => '{{WRAPPER}} .gn-user-menu-footer > .gn-btn > .title',
			)
		);

		$this->add_responsive_control(
			'user_menu_dropdown_sign_out_icon_size',
			array(
				'label'      => esc_html__( 'Icon Size', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
                'range' => [
                    'px' => [
                        'min' => 0,
                        'max' => 30,
                        'step' => 1,
                    ],
                ],
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-footer > .gn-btn > i' => 'font-size: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->start_controls_tabs(
			'user_menu_dropdown_sign_out_tabs'
		);

		$this->start_controls_tab(
			'user_menu_dropdown_sign_out_normal_tab',
			array(
				'label' => esc_html__( 'Normal', 'gigneo' ),
			)
		);

		$this->add_control(
			'user_menu_dropdown_sign_out_icon_color',
			array(
				'label'     => esc_html__( 'Icon Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-footer > .gn-btn > i' => 'color: {{VALUE}};',
					'{{WRAPPER}} .gn-user-menu-footer > .gn-btn > svg' => 'fill: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'user_menu_dropdown_sign_out_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-footer > .gn-btn > .title' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Background::get_type(),
			array(
				'name'     => 'user_menu_dropdown_sign_out_background',
				'types'    => array( 'classic', 'gradient' ),
				'exclude'  => array( 'image' ), // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
				'selector' => '{{WRAPPER}} .gn-user-menu-footer > .gn-btn',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'user_menu_dropdown_sign_out_hover_tab',
			array(
				'label' => esc_html__( 'Hover', 'gigneo' ),
			)
		);

		$this->add_control(
			'user_menu_dropdown_sign_out_icon_color_hover',
			array(
				'label'     => esc_html__( 'Icon Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-footer > .gn-btn:hover > i' => 'color: {{VALUE}};',
					'{{WRAPPER}} .gn-user-menu-footer > .gn-btn:hover > svg' => 'fill: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'user_menu_dropdown_sign_out_text_color_hover',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-footer > .gn-btn:hover > .title' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Background::get_type(),
			array(
				'name'     => 'user_menu_dropdown_sign_out_text_background_hover',
				'types'    => array( 'classic', 'gradient' ),
				'exclude'  => array( 'image' ), // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
				'selector' => '{{WRAPPER}} .gn-user-menu-footer > .gn-btn:hover',
			)
		);

		$this->add_control(
			'user_menu_dropdown_sign_out_border_color_hover',
			array(
				'label'     => esc_html__( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-user-menu-footer > .gn-btn:hover' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'      => 'user_menu_dropdown_sign_out_border',
				'selector'  => '{{WRAPPER}} .gn-user-menu-footer > .gn-btn',
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'user_menu_dropdown_sign_out_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-footer > .gn-btn' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'user_menu_dropdown_sign_out_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-footer > .gn-btn' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'user_menu_dropdown_sign_out_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-menu-footer > .gn-btn' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'section_notifications_toggle_style',
			array(
				'label' => esc_html__( 'Notifications Toggle', 'gigneo' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_responsive_control(
			'notifications_toggle_icon_size',
			array(
				'label'      => esc_html__( 'Icon Size', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'default'    => array(
					'unit' => 'px',
				),
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw', 'custom' ),
				'range'      => array(
					'px' => array(
						'min' => 1,
						'max' => 30,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon > i' => 'font-size: {{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .gn-user-notification .gn-icon > svg' => 'width: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'notifications_toggle_bg_size',
			array(
				'label'      => esc_html__( 'Background Size', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'default'    => array(
					'unit' => 'px',
				),
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw', 'custom' ),
				'range'      => array(
					'px' => array(
						'min' => 1,
						'max' => 50,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon' => 'height: {{SIZE}}{{UNIT}}; width: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->start_controls_tabs(
			'notifications_toggle_tabs'
		);

		$this->start_controls_tab(
			'notifications_toggle_normal_tab',
			array(
				'label' => esc_html__( 'Normal', 'gigneo' ),
			)
		);

		$this->add_control(
			'notifications_toggle_color',
			array(
				'label'     => esc_html__( 'Icon Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon > i' => 'color: {{VALUE}};',
					'{{WRAPPER}} .gn-user-notification .gn-icon > svg' => 'fill: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'notifications_toggle_background',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'notifications_toggle_hover_tab',
			array(
				'label' => esc_html__( 'Hover', 'gigneo' ),
			)
		);

		$this->add_control(
			'notifications_toggle_color_hover',
			array(
				'label'     => esc_html__( 'Icon Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon:hover > i' => 'color: {{VALUE}};',
					'{{WRAPPER}} .gn-user-notification .gn-icon:hover > svg' => 'fill: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'notifications_toggle_background_hover',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon:hover' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'notifications_toggle_border_color_hover',
			array(
				'label'     => esc_html__( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon:hover' => 'border-color: {{VALUE}};',
				),

			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'      => 'notifications_toggle_border',
				'selector'  => '{{WRAPPER}} .gn-user-notification .gn-icon',
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'notifications_toggle_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'notifications_toggle_btn_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'notifications_toggle_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'notification_counter_heading',
			array(
				'label'     => esc_html__( 'Counter', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'notification_counter_typography',
				'selector' => '{{WRAPPER}} .gn-user-notification .gn-icon > .gn-count',
			)
		);

		$this->start_controls_tabs(
			'notification_counter_tabs'
		);

		$this->start_controls_tab(
			'notification_counter_normal_tab',
			array(
				'label' => esc_html__( 'Normal', 'gigneo' ),
			)
		);

		$this->add_control(
			'notification_counter_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon > .gn-count' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'notification_counter_background_color',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon > .gn-count' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'notification_counter_hover_tab',
			array(
				'label' => esc_html__( 'Hover', 'gigneo' ),
			)
		);

		$this->add_control(
			'notification_counter_color_hover',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon:hover > .gn-count' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'notification_counter_background_color_hover',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon:hover > .gn-count' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'notification_counter_border_color_hover',
			array(
				'label'     => esc_html__( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon:hover > .gn-count' => 'border-color: {{VALUE}};',
				),

			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'      => 'notification_counter_border',
				'selector'  => '{{WRAPPER}} .gn-user-notification .gn-icon',
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'notification_counter_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon > .gn-count' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_counter_btn_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon > .gn-count' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_counter_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-notification .gn-icon > .gn-count' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'notification_toggle_dropdown',
			array(
				'label'     => esc_html__( 'Dropdown', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'notification_toggle_dropdown_width',
			array(
				'label'      => esc_html__( 'Width', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'vw' ),
				'range'      => array(
					'px' => array(
						'min' => 0,
						'max' => 1000,
					),
					'vw' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-notification .gn-notification-dropdown' => 'width: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'     => 'notification_toggle_dropdown_border',
				'selector' => '{{WRAPPER}} .gn-user-notification .gn-notification-dropdown',
			)
		);

		$this->add_responsive_control(
			'notification_toggle_dropdown_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-notification .gn-notification-dropdown' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_toggle_dropdown_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-notification .gn-notification-dropdown' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_toggle_dropdown_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-user-notification .gn-notification-dropdown' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'notification_toggle_dropdown_title',
			array(
				'label'     => esc_html__( 'Title', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'notification_toggle_dropdown_title_typo',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-title',
			)
		);

		$this->add_control(
			'notification_toggle_dropdown_title_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-title' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'notification_toggle_dropdown_description',
			array(
				'label'     => esc_html__( 'Description', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'notification_toggle_dropdown_description_typo',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-description',
			)
		);

		$this->add_control(
			'notification_toggle_dropdown_description_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-description' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_toggle_dropdown_description_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-description' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'notification_item_heading',
			array(
				'label'     => esc_html__( 'Notification Item', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'     => 'notification_item_border',
				'selector' => '{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-notification-item',
			)
		);

		$this->add_responsive_control(
			'notification_item_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-notification-item' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_item_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-notification-item' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_item_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-notification-item' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->start_controls_tabs( 'notification_item_tabs' );

		$this->start_controls_tab(
			'notification_item_normal',
			array( 'label' => esc_html__( 'Normal', 'gigneo' ) )
		);

		$this->add_control(
			'notification_item_bg_color',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array( '{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-notification-item' => 'background-color: {{VALUE}};' ),
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'notification_item_hover',
			array( 'label' => esc_html__( 'Hover', 'gigneo' ) )
		);

		$this->add_control(
			'notification_item_bg_color_hover',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array( '{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-notification-item:hover' => 'background-color: {{VALUE}};' ),
			)
		);

		$this->add_control(
			'notification_item_border_color_hover',
			array(
				'label'     => esc_html__( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array( '{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-notification-item:hover' => 'border-color: {{VALUE}};' ),
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_control(
			'notification_item_avatar_heading',
			array(
				'label'     => esc_html__( 'Avatar', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'notification_item_avatar_size',
			array(
				'label'      => __( 'Size', 'gigneo' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'em' ),
				'range'      => array(
					'px' => array(
						'min'  => 10,
						'max'  => 80,
						'step' => 1,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-avatar' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_item_avatar_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-avatar' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_item_avatar_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-avatar' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'notification_item_status_indicator_heading',
			array(
				'label'     => esc_html__( 'Status', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'notification_item_status_indicator_shadow',
				'selector' => '{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-avatar.gn-online:before',
			)
		);

        $this->add_group_control(
            Group_Control_Border::get_type(),
            array(
                'name'      => 'status_border',
                'selector'  => '{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-avatar.gn-online:before',
            )
        );

		$this->add_responsive_control(
			'notification_item_status_indicator_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notifications .gn-avatar.gn-online:before' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'notification_item_title_heading',
			array(
				'label'     => esc_html__( 'Title', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'notification_item_title_typo',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-description',
			)
		);

		$this->add_control(
			'notification_item_title_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-description' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'notification_item_description_heading',
			array(
				'label'     => esc_html__( 'Description', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'notification_item_description_typo',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-description',
			)
		);

		$this->add_control(
			'notification_item_description_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-description' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_item_description_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-description' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'notification_item_date_heading',
			array(
				'label'     => esc_html__( 'Date', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'notification_item_date_typo',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-description',
			)
		);

		$this->add_control(
			'notification_item_date_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-description' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_item_date_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-head .gn-description' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'notification_item_meta_heading',
			array(
				'label'     => esc_html__( 'Meta', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'notification_item_meta_space_between',
			array(
				'label'      => esc_html__( 'Space Between', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'em' ),
				'range'      => array(
					'px' => array(
						'min' => 0,
						'max' => 30,
					),
					'%'  => array(
						'min' => 0,
						'max' => 100,
					),
					'em' => array(
						'min' => 0,
						'max' => 10,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notification-item .gn-head .gn-meta button' => 'margin-left: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_item_meta_size',
			array(
				'label'     => esc_html__( 'Size', 'gigneo' ),
				'type'      => Controls_Manager::SLIDER,
				'range'     => array(
					'px' => array(
						'min' => 6,
						'max' => 30,
					),
				),
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notification-item .gn-btn, .gn-notification-dropdown .gn-notification-item .gn-notification-link' => 'font-size: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'notification_item_meta_icon_color',
			array(
				'label'     => esc_html__( 'Link Icon Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notification-item .gn-notification-link' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'notification_item_meta_email_icon_color',
			array(
				'label'     => esc_html__( 'Notification Icon Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notification-item .gn-dropdown-notification-mark-read' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'notification_item_unread_heading',
			array(
				'label'     => esc_html__( 'Unread', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'notification_item_unread_size',
			array(
				'label'     => esc_html__( 'Size', 'gigneo' ),
				'type'      => Controls_Manager::SLIDER,
				'range'     => array(
					'px' => array(
						'min' => 6,
						'max' => 30,
					),
				),
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notification-item .gn-body:before' => 'height: {{SIZE}}{{UNIT}}; width: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'notification_item_unread_bg_color',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notification-item .gn-body:before' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'notification_item_unread_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-notification-item .gn-body:before' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'view_notification_button',
			array(
				'label'     => esc_html__( 'View Notification Button', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'view_notification_button_typography',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn',
			)
		);

		$this->start_controls_tabs( 'view_notification_button_tabs' );

		$this->start_controls_tab(
			'view_notification_button_normal',
			array( 'label' => esc_html__( 'Normal', 'gigneo' ) )
		);

		$this->add_control(
			'view_notification_button_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'view_notification_button_background',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'view_notification_button_box_shadow',
				'selector' => '{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'view_notification_button_hover',
			array( 'label' => esc_html__( 'Hover', 'gigneo' ) )
		);

		$this->add_control(
			'view_notification_button_color_hover',
			array(
				'label'     => __( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn:hover' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'view_notification_button_background_hover',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn:hover' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'view_notification_button_border_color_hover',
			array(
				'label'     => __( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn:hover' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'view_notification_button_box_shadow_hover',
				'selector' => '{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn:hover',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'view_notification_button_focus',
			array( 'label' => esc_html__( 'Focus', 'gigneo' ) )
		);

		$this->add_control(
			'view_notification_button_color_focus',
			array(
				'label'     => __( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn:focus' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'view_notification_button_background_focus',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn:focus' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'view_notification_button_border_focus',
			array(
				'label'     => __( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn:focus' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'view_notification_button_box_shadow_focus',
				'selector' => '{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn:focus',
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'      => 'view_notification_button_border',
				'separator' => 'before',
				'selector'  => '{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn',
			)
		);

		$this->add_responsive_control(
			'view_notification_button_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'view_notification_button_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-actions .gn-btn' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'view_notification_button_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-actions' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'dropdown_empty_view',
			array(
				'label'     => esc_html__( 'Dropdown Empty View', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'dropdown_empty_view_size',
			array(
				'label'      => __( 'Icon Size', 'gigneo' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'em' ),
				'range'      => array(
					'px' => array(
						'min'  => 10,
						'max'  => 200,
						'step' => 1,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-not-found-image svg' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'dropdown_empty_view_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-notification-dropdown .gn-not-found-wrapper' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'dropdown_empty_view_title',
			array(
				'label'     => esc_html__( 'Title', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'dropdown_empty_view_title_typo',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-not-found-content .gn-not-found-title',
			)
		);

		$this->add_control(
			'dropdown_empty_view_title_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-not-found-content .gn-not-found-title' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'dropdown_empty_view_description',
			array(
				'label'     => esc_html__( 'Description', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'dropdown_empty_view_description_typo',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-not-found-content p',
			)
		);

		$this->add_control(
			'dropdown_empty_view_description_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-not-found-content p' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'dropdown_empty_view_description_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-not-found-content p' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();
	}

	/**
	 * Render widget output on the frontend.
	 *
	 * Uses a template file to separate PHP/HTML from logic.
	 */
	protected function render() {
		//Load Template
		require gigneo_get_template( 'elementor/widgets/user-menu' );
	}
}
